

#include "./common.h"


// ------------------------------------------------------------------------------------------------------

// 5000 samples per second = 20000 samples per 4 seconds ( PC CONNECTED )


// ------------------------------------------------------------------------------------------------- TODO
//  200 samples per second = 12000 samples per minute    ( BATTERY ONLY )
// 5 uS each computation
// 200 computations x 5 uS = 1 mS x 3mA + 999 mS x 2uA   ---> 5 uA 16mips + IDLE sosc
// -----------------------------------------------------------------------------------------------------

// too much consumption using clock switching without idle 
// 200 computations x 5 uS = 1 mS x 3mA + 999 mS x 80uA   ---> 83 uA 16mips + sosc 32KHz


// -----------------------------------------------------------------------------------------------------

// PLB LED - 50 mS each 10 seconds = 2mA / 200 = 10 uA ( can be disabled with energy-saving command )

// TODO SOSC calibration command

// TODO sampling frequency command (every 1 sec - 1 day, 10 sec - 14 days / 30 sec - 40 days / 1 min - 3 months )

// EEPROM 10Mbit

// -----------------------------------------------------------------------------------------------------


#if (MASTER_LOGGER)

	void TestSleep();
	void TestIdle();
	void TestSOSC();
	void Test_ButtonPressed();
	void DisableModules();
	void EnableModules();
	void Logger_IdleLoop();
	void ClockSwitch(uint8 mode);

	uint16 RMS_Value;

	float MidValue = 511.5;
	float SquaredRms = 0;
	
	
	void ClockSwitch(uint8 mode)
	{
		//_SOSCEN = 0;
		__builtin_write_OSCCONL(OSCCON & ~0b00000010);	// soscen = 0 ( disable SOSCI on RB4 )
					
		switch (mode)
		{
			case 0:
			default:
				__builtin_write_OSCCONH(0b010);    // NOSC[] = XT, HS, EC

//		        unsigned int pll_startup_counter = 600;
//		        CLKDIVbits.PLLEN = 1;
//		        while(pll_startup_counter--);
				break;
			case 1:
				//_SOSCEN = 1;
				__builtin_write_OSCCONL(OSCCON | 0b00000010);	// soscen = 1 ( enable SOSCI on RB4 )
				__builtin_write_OSCCONH(0b100);    // NOSC[] = SOSC
				break;
			case 2:
				__builtin_write_OSCCONH(0b000);    // NOSC[] = FRC
				break;
			case 3:
				__builtin_write_OSCCONH(0b101);    // NOSC[] = LPRC
				break;
		}
		//__builtin_write_OSCCONL(0x01);			// Start clock switching (OSWEN = 1)
		__builtin_write_OSCCONL(OSCCON | 0x01);		// Start clock switching (OSWEN = 1)

		switch (mode)
		{
			case 0:
			default:
				while (OSCCONbits.COSC != 0b010) {};    // NOSC[] = XT, HS, EC
				//while (OSCCONbits.LOCK != 1) {};
				break;
			case 1:
				while (OSCCONbits.COSC != 0b100) {};    // NOSC[] = SOSC
				break;
			case 2:
				while (OSCCONbits.COSC != 0b000) {};    // NOSC[] = FRC
				break;
			case 3:
				while (OSCCONbits.COSC != 0b101) {};    // NOSC[] = LPRC
				break;
		}

		while (_OSWEN) {};
	}




	uint8 USB_CONNECTED;
	
	void Logger_IdleLoop()
	{
		LED_G = 1;
		Delay_ms(100);
		LED_G = 0;
		Delay_ms(100);
		LED_G = 1;
		Delay_ms(100);
		LED_G = 0;
		Delay_ms(100);
		LED_G = 1;
		Delay_ms(100);
		LED_G = 0;
		
		

		// ------------------------------------------------------ Set ADC as 13 Tcy conversion time
		AD1CON3 = 0x100C;  // auto sample 16 TAD / ad conversion clock = 13 * TCY
			
		// ------------------------------------------------------ ADC interrupt flags
		_AD1IF = 0;
		_AD1IE = 1;
		
		
		uint16 NumSamples = 0;
		
		//DisableModules();

		ClockSwitch(1);		// SOSC
		//ClockSwitch(2);		// FRC
		//ClockSwitch(3);		// LPRC


		while (1)
		{
			NumSamples++;
			USB_CONNECTED = (NumSamples > 100);
			
			//if (USB_CONNECTED) break;
			if (USB_CONNECTED) asm("RESET");
			
		
			// ------------------------------------------------------ Clock switch to 32 KHz
			//ClockSwitch(1);	// SOSC
			//Delay_ms(5);
			
			// ------------------------------------------------------ Start ADC conversion
			_SAMP = 1;
			
			// ------------------------------------------------------ Go to Idle
			//Idle();
			Nop();
			LED_G = !LED_G;
			Delay_us(100);
			// ------------------------------------------------------ Clock switch to 32 MHz (16 MIPS)
			//ClockSwitch(0);	// XT
			
			// ------------------------------------------------------ Compute RMS value using last sampled
			
			
			// ------------------------------------------------------ Test RTC and copy RMS to EEPROM
			
		} 
		
		
//		EnableModules();
//		
//		_AD1IE = 0;
//
//		//Set ADC as 2 Tcy conversion time
//		AD1CON3 = 0x1001;  // auto sample 16 TAD / ad conversion clock = 2 * TCY
//		
//		LED_G = 1;
	}
	


// ================================ TEST =================================
	extern uint16 TX_TimeOut;

	void LoggerTxByte(uint8 value, uint8 Direction)
	{	
		// --------------------------------- enable TX
		_UTXEN = 1;

		// --------------------------------- 1 or 0 for direction test
		COMM_DIR = Direction;
	
		// --------------------------------- send the byte
		U1TXREG = value;
	
		// --------------------------------- wait the TX end ( requires UTXSEL<1:0> = 01 )
		TMR1 = 0;
		_U1TXIF = 0;
		while (_U1TXIF == 0 && TMR1 < TX_TimeOut);	
		// --------------------------------- wait also the stop bit completion
		TMR1 = 0;
		while (_TRMT == 0 && TMR1 < TX_TimeOut);
		
		// --------------------------------- disable TX
		_UTXEN = 0;

		Delay_us(100);
		COMM_DIR = 0;
	}
// ================================ TEST =================================





	// ----------------------------------------------------------- LoggerManagement - Executed about every 6 uS
	void LoggerManagement()
	{

// ================================ TEST =================================
//		_U1RXIE = 0;
//		static uint16 Counter = 0;
//		static uint8 n = 0;
//
//		//if (Counter == 1000) EmptyRxFifo();
//		
//		if (Counter++ > 20000)
//		{
//			//LED_R = !LED_R;
//			// ------------------------------------------- 1000 = every 5 mS
//			Counter = 0;
//			
//			LoggerTxByte(n, (n % 4 != 0));
//			n++;
//		}
//		return;			// RETURN !!!!!!!!!!!!!!
// ================================ TEST =================================



		//Test_ButtonPressed();

		
		// ------------------------------------------------------- 
		if (_RA0 == 0)
		{
			Logger_IdleLoop();
		}	
		
		
		
		

		// ------------------------------------------------------- ADC management - Executed about every 200 uS
		static uint16 AdcCounter;
		if (++AdcCounter > 20)   
		{		
			AdcCounter = 0;
			
			if (_AD1IF)
			{
				_AD1IF = 0;
				
				float Raw_Value = ADC1BUF0;
				
			
				// ----------------------------------------------- MidValue and RMS  ( floor = 109 watt )
	//			MidValue += (Raw_Value - MidValue) / 10000.0;
	//			Raw_Value -= MidValue;
	//			SquaredRms += (Raw_Value * Raw_Value - SquaredRms) / 5000.0;
	//			RMS_Value = sqrt(SquaredRms) * 40.0;  // 40 or 14.5
				
				
				// ----------------------------------------------- RMS  ( floor = 110 watt )
				Raw_Value -= 512.0;		
				SquaredRms += (Raw_Value * Raw_Value - SquaredRms) / 5000.0;
				RMS_Value = sqrt(SquaredRms) * 40.0;
				
				// ----------------------------------------------- RMS with fast smoothing
	//			Raw_Value -= 512.0;		
	//			float delta = Raw_Value * Raw_Value - SquaredRms;			
	//			if (delta > 0.0) SquaredRms += (delta * delta) / 2000000.0;
	//			else			 SquaredRms -= (delta * delta) / 2000000.0;
	//			RMS_Value = sqrt(SquaredRms) * 40.0;
				
				
				// ----------------------------------------------- raw value test
				//RMS_Value = Raw_Value;
				
				
	
				
				// ----------------------------------------------- speed test 	
				//RMS_Value +=1;
				
	
	//			AD1CHS = 5;
	//			// ------------------------------------------------ wait a minimum of 1 Tad after changing channel 
	//			//                                                  before the "_SAMP = 1"
	//			Nop();
	//			Nop();
				
				_SAMP = 1;		
			}
		}
		

	
	
	
	
		// ------------------------------------------------ test
		// Test_ButtonPressed();
		
		
		// ------------------------------------------------ loop time test	
		//	static uint16 ctr1;
		//	if (++ctr1 > RMS_Value * 300)   
		//	{		
		//		ctr1 = 0;
		//		
		//		COMM_DIR = !COMM_DIR;
		//		
		//	}	
	}
	
	
	void DisableModules()
	{
		// --------------------------------------- USB OFF
		U1CON = 0;
		U1OTGCON = 0;
		U1IE = 0;
		U1EIE = 0;
		U1OTGIE = 0;			
		_USBPWR = 0;

		_USB1IE = 0;
	  	_USB1IF = 0;
		//_DISI = 1;
		//__asm__ volatile ("disi #4");
	
		// -------------------------------------- Disable undesired interrupts
		
		// -------------------------------------- NO WeakPullUp on all unused pins
		_CN4PUE = 0;
		_CN5PUE = 0;
		_CN6PUE = 0;
		_CN7PUE = 0;
		_CN0PUE = 0;
		_CN21PUE = 0;
		_CN22PUE = 0;
		_CN23PUE = 0;
		
	 	// -------------------------------------- IDLE switch off all unused modules
		T1CONbits.TSIDL = 1;
		T2CONbits.TSIDL = 1;
		T3CONbits.TSIDL = 1;
		T4CONbits.TSIDL = 1;
		T5CONbits.TSIDL = 1;
		IC1CON1bits.ICSIDL = 1;
		IC2CON1bits.ICSIDL = 1;
		IC3CON1bits.ICSIDL = 1;
		IC4CON1bits.ICSIDL = 1;
		IC5CON1bits.ICSIDL = 1;
		SPI1STATbits.SPISIDL = 1;
		SPI2STATbits.SPISIDL = 1;
		I2C1CONbits.I2CSIDL = 1;
		I2C2CONbits.I2CSIDL = 1;
		U1MODEbits.USIDL = 1;
		U2MODEbits.USIDL = 1;
		_USBSIDL = 1;
		_PSIDL = 1;
		_CSIDL = 1;
		_ADSIDL = 0;		// ADC enabled in Idle Mode
		_CMIDL = 1;
		_CTMUSIDL = 1;
		
		//_POSCEN = 1;	// 1 = Primary Oscillator continues to operate during Sleep mode
	}
	
	
	
//	void EnableModules()
//	{
//		// --------------------------------------- USB ON
//		U1CON = 1;
//		U1OTGCON = 1;
//		U1IE = 1;
//		U1EIE = 1;
//		U1OTGIE = 1;			
//		_USBPWR = 1;
//		
//		_USB1IE = 1;
//	  	_USB1IF = 1;
//
//		//_DISI = 1;
//		//__asm__ volatile ("disi #4");
//	
//		// -------------------------------------- Disable undesired interrupts
//		
//		// -------------------------------------- WeakPullUp on all unused pins
//		_CN4PUE = 1;
//		_CN5PUE = 1;
//		_CN6PUE = 1;
//		_CN7PUE = 0;
//		_CN0PUE = 1;
//		_CN21PUE = 1;
//		_CN22PUE = 1;
//		_CN23PUE = 0;
//		
////	 	// -------------------------------------- IDLE switch off all unused modules
////		T1CONbits.TSIDL = 0;
////		T2CONbits.TSIDL = 0;
////		T3CONbits.TSIDL = 0;
////		T4CONbits.TSIDL = 0;
////		T5CONbits.TSIDL = 0;
////		IC1CON1bits.ICSIDL = 0;
////		IC2CON1bits.ICSIDL = 0;
////		IC3CON1bits.ICSIDL = 0;
////		IC4CON1bits.ICSIDL = 0;
////		IC5CON1bits.ICSIDL = 0;
////		SPI1STATbits.SPISIDL = 0;
////		SPI2STATbits.SPISIDL = 0;
////		I2C1CONbits.I2CSIDL = 0;
////		I2C2CONbits.I2CSIDL = 0;
////		U1MODEbits.USIDL = 0;
////		U2MODEbits.USIDL = 0;
////		_USBSIDL = 0;
////		_PSIDL = 0;
////		_CSIDL = 0;
////		_ADSIDL = 0;
////		_CMIDL = 0;
////		_CTMUSIDL = 0;
//		
//		//_POSCEN = 1;	// 1 = Primary Oscillator continues to operate during Sleep mode
//	}	
	
	
	
	
	
	
	
	
	
	
	
	
	// -------------------------------------------------------------------------------------------
	//   TEST
	// -------------------------------------------------------------------------------------------
	
	
	
	void Test_ButtonPressed()
	{
		static uint16 TestButtonPressed = 0;
		if (_RA0 == 0)
		{
			if (TestButtonPressed++ > 60000)
			{
				LED_G = 1;
				Delay_ms(100);
				LED_G = 0;
				Delay_ms(100);
				LED_G = 1;
				Delay_ms(100);
				LED_G = 0;
				Delay_ms(100);
				LED_G = 1;
				Delay_ms(100);
				LED_G = 0;
				Delay_ms(100);
				LED_G = 1;
				Delay_ms(100);
				LED_G = 0;
				Delay_ms(100);
				LED_G = 1;
				Delay_ms(100);
				LED_G = 0;
				Delay_ms(100);
				LED_G = 1;
				
				// TestSleep();
				// TestIdle();
				TestSOSC();
			}
		}
		else
			TestButtonPressed = 0;
	}
	
	
	
	
	
	void TestSleep()
	{
		// ----------------------------------- USB OFF
		U1CON = 0;
		U1OTGCON = 0;
		U1IE = 0;
		U1EIE = 0;
		U1OTGIE = 0;			
		_USBPWR = 0;

		_USB1IE = 0;
	  	_USB1IF = 0;
		//_DISI = 1;
		//__asm__ volatile ("disi #4");
	
		// ----------------------------------- all Interrupts disabled
		_T5IE = 0;
		
		// ----------------------------------- RA0(buttons) and RA1 (latch) as digital input without pullup
		_PCFG0 = 1;		
		_PCFG1 = 1;
		_CN1PUE = 0;
		_CN2PUE = 0;
		
		// ----------------------------------------------- NO WeakPullUp on all unused pins
		_CN4PUE = 0;
		_CN5PUE = 0;
		_CN6PUE = 0;
		_CN7PUE = 0;
		_CN0PUE = 0;
		_CN21PUE = 0;
		_CN22PUE = 0;
		_CN23PUE = 0;
		
		// ----------------------------------- enable wakeup on change
		PORTA; 
		_CNIF = 0;
		_CNIE = 1;
		_CN2IE = 1;
		
		// -----------------------------------
		Delay_ms(3000);
		
	
		// --------------------------------------------------------------------------------------- 
		PMD1 = 0xFFFF;
		PMD2 = 0xFFFF;
		PMD3 = 0xFFFF;
		PMD4 = 0xFFFF;
		
		//_POSCEN = 1;	// 1 = Primary Oscillator continues to operate during Sleep mode
		
		LED_G = 0;

		// ------------------------------------------ sleep
		//_DSEN = 1;
		Sleep();
		Nop();
		Delay_ms(500);
		asm("RESET");
	}
	
	
	
	void TestIdle()
	{
		// ----------------------------------- USB OFF
		U1CON = 0;
		U1OTGCON = 0;
		U1IE = 0;
		U1EIE = 0;
		U1OTGIE = 0;			
		_USBPWR = 0;


		
		_USB1IE = 0;
	  	_USB1IF = 0;
		//_DISI = 1;
		//__asm__ volatile ("disi #4");
	
		// ----------------------------------- all Interrupts disabled
		_T5IE = 0;
		
		// ----------------------------------- RA0(buttons) and RA1 (latch) as digital input without pullup
		_PCFG0 = 1;		
		_PCFG1 = 1;
		_CN1PUE = 0;
		_CN2PUE = 0;
		
		// ----------------------------------------------- NO WeakPullUp on all unused pins
		_CN4PUE = 0;
		_CN5PUE = 0;
		_CN6PUE = 0;
		_CN7PUE = 0;
		_CN0PUE = 0;
		_CN21PUE = 0;
		_CN22PUE = 0;
		_CN23PUE = 0;
		
		// ----------------------------------- enable wakeup on change
		PORTA; 
		_CNIF = 0;
		_CNIE = 1;
		_CN2IE = 1;
		
		// -----------------------------------
		Delay_ms(3000);
		
	 	// ---------------------------------------------------------------------- IDLE switch off all unused modules
		T1CONbits.TSIDL = 1;
		T2CONbits.TSIDL = 1;
		T3CONbits.TSIDL = 1;
		T4CONbits.TSIDL = 1;
		T5CONbits.TSIDL = 1;
		IC1CON1bits.ICSIDL = 1;
		IC2CON1bits.ICSIDL = 1;
		IC3CON1bits.ICSIDL = 1;
		IC4CON1bits.ICSIDL = 1;
		IC5CON1bits.ICSIDL = 1;
		SPI1STATbits.SPISIDL = 1;
		SPI2STATbits.SPISIDL = 1;
		I2C1CONbits.I2CSIDL = 1;
		I2C2CONbits.I2CSIDL = 1;
		U1MODEbits.USIDL = 1;
		U2MODEbits.USIDL = 1;
		_USBSIDL = 1;
		_PSIDL = 1;
		_CSIDL = 1;
		_ADSIDL = 1;
		_CMIDL = 1;
		_CTMUSIDL = 1;
		

		LED_G = 0;

		_SOSCEN = 1;
				
		// --------------------------------------------------------------------------------------- CLOCK SWITCHING
		//__builtin_write_OSCCONH(0b000);    // NOSC[] = FRC
		__builtin_write_OSCCONH(0b101);    // NOSC[] = LPRC
		//__builtin_write_OSCCONH(0b010);    // NOSC[] = XT, HS, EC
		//__builtin_write_OSCCONH(0b100);    // NOSC[] = SOSC
		
		__builtin_write_OSCCONL(0x01);    // Start clock switching (OSWEN = 1)
		//while (OSCCONbits.COSC != 0b101) {};
		//while (OSCCONbits.LOCK != 1) {};
		//while (_OSWEN) {};
		

		// --------------------------------------------------------------------------------------- 
		//PMD1 = 0xFFFF;
		//PMD2 = 0xFFFF;
		//PMD3 = 0xFFFF;
		//PMD4 = 0xFFFF;
		
		//_POSCEN = 1;	// 1 = Primary Oscillator continues to operate during Sleep mode
	
		// ------------------------------------------ idle
		Idle();
		Nop();
		Delay_ms(500);
		asm("RESET");
	}
	
	
	
	void TestSOSC()
	{
		// ----------------------------------- USB OFF
		U1CON = 0;
		U1OTGCON = 0;
		U1IE = 0;
		U1EIE = 0;
		U1OTGIE = 0;			
		_USBPWR = 0;


		
		_USB1IE = 0;
	  	_USB1IF = 0;
		//_DISI = 1;
		//__asm__ volatile ("disi #4");
	
		// ----------------------------------- all Interrupts disabled
		_T5IE = 0;
		
		// ----------------------------------- RA0(buttons) and RA1 (latch) as digital input without pullup
		_PCFG0 = 1;		
		_PCFG1 = 1;
		_CN1PUE = 0;
		_CN2PUE = 0;
		
		// ----------------------------------------------- NO WeakPullUp on all unused pins
		_CN4PUE = 0;
		_CN5PUE = 0;
		_CN6PUE = 0;
		_CN7PUE = 0;
		_CN0PUE = 0;
		_CN21PUE = 0;
		_CN22PUE = 0;
		_CN23PUE = 0;
		
		// ----------------------------------- enable wakeup on change
		PORTA; 
		_CNIF = 0;
		_CNIE = 1;
		_CN2IE = 1;
		
		// -----------------------------------
		Delay_ms(3000);
		
	 	// ---------------------------------------------------------------------- IDLE switch off all unused modules
//		T1CONbits.TSIDL = 1;
//		T2CONbits.TSIDL = 1;
//		T3CONbits.TSIDL = 1;
//		T4CONbits.TSIDL = 1;
//		T5CONbits.TSIDL = 1;
//		IC1CON1bits.ICSIDL = 1;
//		IC2CON1bits.ICSIDL = 1;
//		IC3CON1bits.ICSIDL = 1;
//		IC4CON1bits.ICSIDL = 1;
//		IC5CON1bits.ICSIDL = 1;
//		SPI1STATbits.SPISIDL = 1;
//		SPI2STATbits.SPISIDL = 1;
//		I2C1CONbits.I2CSIDL = 1;
//		I2C2CONbits.I2CSIDL = 1;
//		U1MODEbits.USIDL = 1;
//		U2MODEbits.USIDL = 1;
//		_USBSIDL = 1;
//		_PSIDL = 1;
//		_CSIDL = 1;
//		_ADSIDL = 1;
//		_CMIDL = 1;
//		_CTMUSIDL = 1;
		

		LED_G = 0;

		_SOSCEN = 1;
				
		// --------------------------------------------------------------------------------------- CLOCK SWITCHING
		//__builtin_write_OSCCONH(0b000);    // NOSC[] = FRC
		__builtin_write_OSCCONH(0b101);    // NOSC[] = LPRC
		//__builtin_write_OSCCONH(0b010);    // NOSC[] = XT, HS, EC
		//__builtin_write_OSCCONH(0b100);    // NOSC[] = SOSC
		
		__builtin_write_OSCCONL(0x01);    // Start clock switching (OSWEN = 1)
		//while (OSCCONbits.COSC != 0b100) {};
		//while (OSCCONbits.LOCK != 1) {};
		//while (_OSWEN) {};
		

		// --------------------------------------------------------------------------------------- 
//		PMD1 = 0xFFFF;
//		PMD2 = 0xFFFF;
//		PMD3 = 0xFFFF;
//		PMD4 = 0xFFFF;
		
		//_POSCEN = 1;	// 1 = Primary Oscillator continues to operate during Sleep mode
	
		// ------------------------------------------ idle
		while (_RA0 == 1)
		{
			LED_G = 1;
			Delay_ms(5);
			LED_G = 0;
			Delay_ms(5);
		}	
		
		
		asm("RESET");
		
		// --------------------------------------------------------------------------------------- RESTORE CLOCK
		//__builtin_write_OSCCONH(0b011);   // NOSC[] = XTPLL, HSPLL, ECPLL
		//__builtin_write_OSCCONL(0x01);    // Start clock switching (OSWEN = 1)
		//while (OSCCONbits.COSC != 0b000) {};
		//while (OSCCONbits.LOCK != 1) {};
		//while (_OSWEN) {};
	}
	

#endif



	// ---------------------------------------------------------------------------------------
	//				_ROSSLP = 0;	// 0 = Disable clock-out in Sleep mode


	
	// ---------------------------------------------------------------------------------------
	//				TRISA = 0b1111111111111111;								
	//				LATA  = 0b0000000000000000;
	//				TRISB = 0b1111111111111111;								
	//				LATB  = 0b0000000000000000;


	
	// --------------------------------------------------------------------------------------- CLOCK SWITCHING
	//    			__builtin_write_OSCCONH(0b000);    // NOSC[] = FRC
	//    			__builtin_write_OSCCONL(0x01);    // Start clock switching (OSWEN = 1)
	//    			while (OSCCONbits.COSC != 0b000) {};
	//    			while (OSCCONbits.LOCK != 1) {};
	//    			while (_OSWEN) {};



