

#include "./common.h"



#if (MASTER_SNIFFER)

	uint8 SniffedBytes[SNIFFED_SIZE];
	//uint8 SniffedFlags[SNIFFED_SIZE];
	uint8 SniffedFlags[UART1_RX_FIFO_SIZE];
	uint8 SniffedIndex = 0;

	void SnifferManagement();


	extern uint16 TX_TimeOut;

	void SnifferTxByte(uint8 value, uint8 Direction)
	{	
		// --------------------------------- enable TX
		_UTXEN = 1;

		#if (SNIFFER_LOOPBACK)
			// --------------------------------- 1 or 0 for direction test
			COMM_DIR = Direction;
		#endif
	
		// --------------------------------- send the byte
		U1TXREG = value;
	
		// --------------------------------- wait the TX end ( requires UTXSEL<1:0> = 01 )
		TMR1 = 0;
		_U1TXIF = 0;
		while (_U1TXIF == 0 && TMR1 < TX_TimeOut);	
		// --------------------------------- wait also the stop bit completion
		TMR1 = 0;
		while (_TRMT == 0 && TMR1 < TX_TimeOut);
		
		// --------------------------------- disable TX
		_UTXEN = 0;

		#if (SNIFFER_LOOPBACK)
			//Delay_us(100);
			COMM_DIR = 0;
		#endif
	}


	// ---------------------------- SnifferManagement - Executed about every 5 uS
	void SnifferManagement()
	{
		#if (SNIFFER_LOOPBACK)
			static uint16 Counter = 0;
			static uint8 n = 0;
	
			//if (Counter == 1000) EmptyRxFifo();
			
			if (Counter++ > 1000)
			{
				//LED_R = !LED_R;
				// ------------------------------------------- 1000 = every 5 mS
				Counter = 0;
				
				SnifferTxByte(n, (n % 4 != 0));
				n++;
			}
		#endif
	}
	

#endif



